/* meko
 * Copyright (C) 2001 Scott James Remnant <scott@netsplit.com>.
 * All Rights Reserved.
 *
 * meko-connection-chooser.h
 * -- 
 * $Id: meko-connection-chooser.h,v 1.6.4.1 2001/11/23 22:34:44 scott Exp $
 * 
 * This file is distributed according to the GNU General Public
 * License.  For full details, read the top of 'main.c' or the
 * file called COPYING that was distributed with this code.
 */

#ifndef _MEKO_CONNECTION_CHOOSER_H
#define _MEKO_CONNECTION_CHOOSER_H

#include <glib.h>
#include <gtk/gtkobject.h>
#include <gtk/gtkwidget.h>
#include <libgnome/gnome-defs.h>
#include <libgnomeui/gnome-dialog.h>
#include <glade/glade-xml.h>

/* Convenience defines */
#define MEKO_TYPE_CONNECTION_CHOOSER \
	(meko_connection_chooser_get_type())
#define MEKO_CONNECTION_CHOOSER(obj) \
	(GTK_CHECK_CAST((obj), MEKO_TYPE_CONNECTION_CHOOSER, \
			MekoConnectionChooser))
#define MEKO_CONNECTION_CHOOSER_CLASS(klass) \
	(GTK_CHECK_CLASS_CAST((klass), MEKO_TYPE_CONNECTION_CHOOSER, \
			      MekoConnectionChooserKlass))
#define MEKO_IS_CONNECTION_CHOOSER(obj) \
	(GTK_CHECK_TYPE((obj), MEKO_TYPE_CONNECTION_CHOOSER))
#define MEKO_IS_CONNECTION_CHOOSER_CLASS(klass) \
	(GTK_CHECK_CLASS_TYPE((klass), MEKO_TYPE_CONNECTION_CHOOSER))


/* Typedefs */
typedef struct _meko_connection_chooser       MekoConnectionChooser;
typedef struct _meko_connection_chooser_class MekoConnectionChooserClass;

/* Instance data */
struct _meko_connection_chooser {
	GnomeDialog dialog;

	/* Private stuff */
	GtkWidget *entry_id, *entry_password, *checkbox_ssl;

	gchar *hostname, *port;
};

/* Object class data */
struct _meko_connection_chooser_class {
	GnomeDialogClass parent_class;

	/* Signals */
	void (*construct)(MekoConnectionChooser *);
};


/* Required functions */
GtkWidget *meko_connection_chooser_new(void);
GtkType	   meko_connection_chooser_get_type(void);

/* Get what they want to connect to and as */
void meko_connection_chooser_get_selection(MekoConnectionChooser *,
					   gchar **, gchar **,
					   gchar **, gchar **);
gboolean meko_connection_chooser_get_ssl_flag(MekoConnectionChooser *);

#endif /* !_MEKO_CONNECTION_CHOOSER_H */
