/* meko
 * Copyright (C) 2001 Scott James Remnant <scott@netsplit.com>.
 * All Rights Reserved.
 *
 * meko-main-window.h
 * -- 
 * $Id: meko-main-window.h,v 1.1.4.1 2001/11/24 00:58:42 scott Exp $
 * 
 * This file is distributed according to the GNU General Public
 * License.  For full details, read the top of 'main.c' or the
 * file called COPYING that was distributed with this code.
 */

#ifndef _MEKO_MAIN_WINDOW_H
#define _MEKO_MAIN_WINDOW_H

#include <glib.h>
#include <gtk/gtkobject.h>
#include <gtk/gtkwidget.h>
#include <libgnome/gnome-defs.h>
#include <libgnomeui/gnome-app.h>

#include "say2/say2-server.h"

/* Convenience defines */
#define MEKO_TYPE_MAIN_WINDOW \
	(meko_main_window_get_type())
#define MEKO_MAIN_WINDOW(obj) \
	(GTK_CHECK_CAST((obj), MEKO_TYPE_MAIN_WINDOW, MekoMainWindow))
#define MEKO_MAIN_WINDOW_CLASS(klass) \
	(GTK_CHECK_CLASS_CAST((klass), MEKO_TYPE_MAIN_WINDOW, \
			      MekoMainWindowKlass))
#define MEKO_IS_MAIN_WINDOW(obj) \
	(GTK_CHECK_TYPE((obj), MEKO_TYPE_MAIN_WINDOW))
#define MEKO_IS_MAIN_WINDOW_CLASS(klass) \
	(GTK_CHECK_CLASS_TYPE((klass), MEKO_TYPE_MAIN_WINDOW))


/* Typedefs */
typedef struct _meko_main_window       MekoMainWindow;
typedef struct _meko_main_window_class MekoMainWindowClass;

/* Instance data */
struct _meko_main_window {
	GtkWindow window;

	/* Private stuff */
	GtkWidget *interface;

	guint idle_timeout;
};

/* Object class data */
struct _meko_main_window_class {
	GtkWindowClass window_class;
};


/* Required functions */
GtkWidget *meko_main_window_new(void);
GtkType	   meko_main_window_get_type(void);

/* Set what server this is going to be for */
void meko_main_window_set(MekoMainWindow *, Say2Server *);

#endif /* !_MEKO_MAIN_WINDOW_H */
