/* meko
 * Copyright (C) 2001 Scott James Remnant <scott@netsplit.com>.
 * All Rights Reserved.
 *
 * meko-private-window.h
 * -- 
 * $Id: meko-private-window.h,v 1.1 2001/09/14 11:59:34 scott Exp $
 * 
 * This file is distributed according to the GNU General Public
 * License.  For full details, read the top of 'main.c' or the
 * file called COPYING that was distributed with this code.
 */

#ifndef _MEKO_PRIVATE_WINDOW_H
#define _MEKO_PRIVATE_WINDOW_H

#include <glib.h>
#include <gtk/gtkobject.h>
#include <gtk/gtkwidget.h>
#include <gtk/gtkwindow.h>

#include "say2/say2-server.h"
#include "say2/say2-user.h"

/* Convenience defines */
#define MEKO_TYPE_PRIVATE_WINDOW \
	(meko_private_window_get_type())
#define MEKO_PRIVATE_WINDOW(obj) \
	(GTK_CHECK_CAST((obj), MEKO_TYPE_PRIVATE_WINDOW, MekoPrivateWindow))
#define MEKO_PRIVATE_WINDOW_CLASS(klass) \
	(GTK_CHECK_CLASS_CAST((klass), MEKO_TYPE_PRIVATE_WINDOW, \
			      MekoPrivateWindowKlass))
#define MEKO_IS_PRIVATE_WINDOW(obj) \
	(GTK_CHECK_TYPE((obj), MEKO_TYPE_PRIVATE_WINDOW))
#define MEKO_IS_PRIVATE_WINDOW_CLASS(klass) \
	(GTK_CHECK_CLASS_TYPE((klass), MEKO_TYPE_PRIVATE_WINDOW))


/* Typedefs */
typedef struct _meko_private_window       MekoPrivateWindow;
typedef struct _meko_private_window_class MekoPrivateWindowClass;

/* Instance data */
struct _meko_private_window {
	GtkWindow window;

	/* Private stuff */
	GtkWidget *interface;
};

/* Object class data */
struct _meko_private_window_class {
	GtkWindowClass window_class;
};


/* Required functions */
GtkWidget *meko_private_window_new(void);
GtkType	   meko_private_window_get_type(void);

/* Set who we're going to be chatting to */
void meko_private_window_set(MekoPrivateWindow *, Say2Server *, Say2User *);

#endif /* !_MEKO_PRIVATE_WINDOW_H */
