# check for a gnome-config library and version
# scott, jul 2001
dnl MEKO_CHECK_LIB(DISPLAY, PKGNAME[, MINIMUM-VERSION[, MAXIMUM-VERSION]])
dnl Test for a gnome-config library and check its version
dnl 
AC_DEFUN(MEKO_CHECK_LIB, [
	dispname="$1"
	pkgname="$2"
	minvers="$3"
	maxvers="$4"

	AC_MSG_CHECKING(for $dispname)
	if $GNOME_CONFIG --libs $pkgname > /dev/null 2>&1; then
		pkgvers=`$GNOME_CONFIG --modversion $pkgname | sed 's/^[[^0-9]]*//'`
	else
		pkgvers=not
	fi
	AC_MSG_RESULT($pkgvers found)

	pkgvers=`echo $pkgvers | awk -F. '{ print $[]1 * 1000000 + $[]2 * 10000 + $[]3 * 100 + $[]4;}'`
	cmpminvers=`echo $minvers | awk -F. '{ print $[]1 * 1000000 + $[]2 * 10000 + $[]3 * 100 + $[]4;}'`
	cmpmaxvers=`echo $maxvers | awk -F. '{ print $[]1 * 1000000 + $[]2 * 10000 + $[]3 * 100 + $[]4;}'`
	ok=yes

	if test -n "$minvers"; then
		if test "$pkgvers" -lt $cmpminvers; then
			ok=no
		fi
	fi
	if test -n "$maxvers"; then
		if test "$pkgvers" -gt $cmpmaxvers; then
			ok=no
		fi
	fi

	if test $ok = no; then
		dispvers=""
		case $maxvers in
		"")
			if -n "$minvers"; then
				dispvers="$minvers or higher"
			fi
			;;
		$minvers)
			if -n "$minvers"; then
				dispvers="$minvers (exactly)"
			fi
			;;
		*)
			if -n "$minvers"; then
				dispvers="$minvers to $maxvers"
			else
				dispvers="$maxvers or lower"
			fi
			;;
		esac

		AC_MSG_ERROR([
*** $dispname $dispvers is required to build Meko.])
	else
		MEKO_GNOME_NEEDED="$MEKO_GNOME_NEEDED $pkgname"
		AC_SUBST(MEKO_GNOME_NEEDED)
	fi
])
