/* meko
 * Copyright (C) 2001 Scott James Remnant <scott@netsplit.com>.
 * All Rights Reserved.
 *
 * say2-channel.h
 * -- 
 * $Id: say2-channel.h,v 1.6 2001/08/31 06:58:07 scott Exp $
 * 
 * This file is distributed according to the GNU General Public
 * License.  For full details, read the top of 'main.c' or the
 * file called COPYING that was distributed with this code.
 */

#ifndef _MEKO_SAY2_CHANNEL_H
#define _MEKO_SAY2_CHANNEL_H

/* Required includes */
#include <glib.h>
#include <gtk/gtkobject.h>

#include "say2/say2-client.h"
#include "say2/say2-user.h"

/* Convenience defines */
#define SAY2_TYPE_CHANNEL \
	(say2_channel_get_type())
#define SAY2_CHANNEL(obj) \
	(GTK_CHECK_CAST((obj), SAY2_TYPE_CHANNEL, Say2Channel))
#define SAY2_CHANNEL_CLASS(klass) \
	(GTK_CHECK_CLASS_CAST((klass), SAY2_TYPE_CHANNEL, Say2ChannelClass))
#define SAY2_IS_CHANNEL(obj) \
	(GTK_CHECK_TYPE((obj), SAY2_TYPE_CHANNEL))
#define SAY2_IS_CHANNEL_CLASS(klass) \
	(GTK_CHECK_CLASS_TYPE((klass), SAY2_TYPE_CHANNEL))

/* Typedefs */
typedef struct _say2_channel       Say2Channel;
typedef struct _say2_channel_class Say2ChannelClass;

/* Instance data */
struct _say2_channel {
	Say2Client client;

	/* List of members */
	GHashTable *members;
};

/* Object class data */
struct _say2_channel_class {
	Say2ClientClass parent_class;

	void (*signon)(Say2Channel *, Say2User *);
	void (*signoff)(Say2Channel *, Say2User *);
};


/* Required functions */
Say2Channel *say2_channel_new(const gchar *);
GtkType	     say2_channel_get_type(void);

/* Add and remove channel members */
void say2_channel_add_member(Say2Channel *, Say2User *);
void say2_channel_remove_member(Say2Channel *, Say2User *);

/* Get a member */
Say2User *say2_channel_get_member(Say2Channel *, const gchar *);

#endif /* !_MEKO_SAY2_CHANNEL_H */
