/* meko
 * Copyright (C) 2001 Scott James Remnant <scott@netsplit.com>.
 * All Rights Reserved.
 *
 * say2-message.h
 * -- 
 * $Id: say2-message.h,v 1.4.4.2 2001/11/23 22:34:44 scott Exp $
 * 
 * This file is distributed according to the GNU General Public
 * License.  For full details, read the top of 'main.c' or the
 * file called COPYING that was distributed with this code.
 */

#ifndef _MEKO_SAY2_MESSAGE_H
#define _MEKO_SAY2_MESSAGE_H

/* The message enum */
typedef enum {
	SAY2_MSG_ANY,

	/* Server Messages */
	SAY2_MSG_CONNECTING,		/* Connecting to server */
	SAY2_MSG_CONNECTION_FAILED,	/* Connection to server failed */
	SAY2_MSG_CONNECTED,		/* Connected */
	SAY2_MSG_NEED_LOGIN,		/* Need a login */
	SAY2_MSG_DISCONNECTED,		/* Disconnected */
        SAY2_MSG_SSL_SUCCESS,		/* SSL established */
	SAY2_MSG_SSL_FAILED,		/* SSL not established */

	/* Error Messages */
	SAY2_MSG_ERROR,			/* Error: command? text */
	SAY2_MSG_BAD_ENAML,		/* Bad Enaml: enaml */
	SAY2_MSG_BAD_COMMAND,		/* Bad Command: command text */
	SAY2_MSG_BAD_NICKNAME,		/* Bad Nickname: nick text */
	SAY2_MSG_BAD_ADDRESS,		/* Bad Address: address text */

	/* Things about us and the server */
	SAY2_MSG_SERVER_INFO,		/* Info: software version uptime text?*/
	SAY2_MSG_MOTD,			/* Motd: text */
	SAY2_MSG_WELCOME,		/* Welcome: attached:bool? */
	SAY2_MSG_LOGOUT,		/* Logout: detached? text? */
	SAY2_MSG_REPLICANT_NEW,		/* New Replicant: host */
	SAY2_MSG_REPLICANT_GONE,	/* Replicant Left: host */
	SAY2_MSG_ATTRIBUTES_SET,	/* Your attributes set: list? */
	SAY2_MSG_PREFS,			/* Pref: tagline? notify? icon:bool
						 password:bool */

	/* Generic non-user/non-channel messages */
	SAY2_MSG_NICK_NOT_PRESENT,	/* Not Present: nick */
	SAY2_MSG_CLIENT_INVALID,	/* Invalid Client: type id */
	SAY2_MSG_MEMBERS,		/* Members: type list */
	SAY2_MSG_WALL,			/* Wall: time user text */

	/* User Messages */
	SAY2_MSG_USER_INVALID,		/* Invalid User */
	SAY2_MSG_USER_INFO,		/* Whois information received */
	SAY2_MSG_USER_ATTRIBUTES,	/* Attribute information received */
	SAY2_MSG_USER_STATUS,		/* Status: time mode text? messages:b */
	SAY2_MSG_USER_NICK,		/* Nick Change: old-nick */
	SAY2_MSG_USER_BOOTED,		/* Booted: by:user text */
	SAY2_MSG_USER_TEXT,		/* User message: time text */
	SAY2_MSG_USER_ACT,		/* User action: time text */
	SAY2_MSG_USER_TEXT_TO,		/* time text user stored:bool */
	SAY2_MSG_USER_ACT_TO,		/* time text user stored:bool */

	/* Channel Messages */
	SAY2_MSG_CHAN_INVALID,		/* Invalid Channel */
	SAY2_MSG_CHAN_MEMBERS,		/* Channel Members: list */
	SAY2_MSG_CHAN_SIGNON,		/* Signon: time user */
	SAY2_MSG_CHAN_SIGNOFF,		/* Signoff: time user */
	SAY2_MSG_CHAN_TEXT,		/* Message: time user text */
	SAY2_MSG_CHAN_ACT,		/* Action: time user text */

	SAY2_MSG_LAST
} Say2MessageType;

#endif /* !_MEKO_SAY2_MESSAGE_H */
