#include <meko.h>

#include <stdio.h>

#include <gtk/gtkmain.h>
#include <gtk/gtksignal.h>
#include <gtk/gtkwidget.h>
#include <gtk/gtkcontainer.h>
#include <gtk/gtkwindow.h>
#include <libgnome/gnome-defs.h>
#include <libgnome/gnome-i18n.h>
#include <libgnomeui/gnome-init.h>

#include "say2/say2-server.h"
#include "say2/say2-channel.h"
#include "widgets/chat-interface/meko-chat-interface.h"

static void
destroy_cb(GtkWidget *widget, gpointer data)
{
	gtk_main_quit();
}

int
main(int argc, char *argv[])
{
	Say2Server  *server;
	Say2Channel *channel;
	Say2User    *me;
	GtkWidget   *win, *wid;
	FILE        *fd;
	char         icon[4096];
	int          icon_sz;

	bindtextdomain(PACKAGE, MEKO_LOCALEDIR);
	textdomain(PACKAGE);

	gnome_init(APPNAME, VERSION, argc, argv);

	server = say2_server_new();
	channel = server->party_line;

        fd = fopen("/home/scott/me-say2.png", "r");
        icon_sz = fread(icon, 1, sizeof(icon), fd);
        fclose(fd);

	me = say2_server_get_me(server);
        gtk_object_set(GTK_OBJECT(me),
                      "guest", TRUE,
                      "nick", "Keybum",
                      "email", "scott@netsplit.com",
                      "tagline", "I dream of sitting beside the setting sun "
                                 "and watching the world go down",
		      "status", SAY2_USER_ACTIVE,
                      NULL);
	say2_client_set_icon(SAY2_CLIENT(me), icon, icon_sz);
	say2_client_set_attr(SAY2_CLIENT(me), "sex", "male");
        say2_client_set_attr(SAY2_CLIENT(me), "sexuality", "gay");

	win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_container_set_border_width(GTK_CONTAINER(win), 2);
	gtk_signal_connect(GTK_OBJECT(win), "destroy",
			   GTK_SIGNAL_FUNC(destroy_cb), NULL);

	wid = meko_chat_interface_new(server, NULL);
	gtk_container_add(GTK_CONTAINER(win), wid);
	gtk_widget_show(wid);

	gtk_widget_show(win);

	gtk_main();

	return 0;
}
