#include <meko.h>

#include <stdio.h>

#include <gtk/gtkmain.h>
#include <gtk/gtkwidget.h>
#include <gtk/gtkcontainer.h>
#include <gtk/gtkwindow.h>
#include <gtk/gtkbox.h>
#include <gtk/gtkvbox.h>
#include <libgnome/gnome-defs.h>
#include <libgnome/gnome-i18n.h>
#include <libgnomeui/gnome-init.h>

#include "say2/say2-client.h"
#include "say2/say2-channel.h"
#include "say2/say2-user.h"
#include "widgets/client-info/meko-client-info.h"

int
main(int argc, char *argv[])
{
	GtkWidget   *win, *box, *wid;
	Say2User    *user;
	Say2Channel *channel;

	FILE	    *fd;
	char	     icon[4096];
	int	     icon_sz;

	bindtextdomain(PACKAGE, MEKO_LOCALEDIR);
	textdomain(PACKAGE);

	gnome_init(APPNAME, VERSION, argc, argv);

	fd = fopen("/home/scott/me-say2.png", "r");
	icon_sz = fread(icon, 1, sizeof(icon), fd);
	fclose(fd);

	user = SAY2_USER(gtk_object_new(
		SAY2_TYPE_USER,
		"id", "keybuk",
		"guest", FALSE,
		"nick", "Keybuk",
		"email", "scott@netsplit.com",
		"tagline", "Saving the world from disaster since 1980!",
		"client", "Meko 0.10.0",
		"host", "localhost",
		"status", SAY2_USER_BUSY,
		"status_msg", "Programming more of Meko",
		"status_time", time(NULL),
		NULL
	));
	say2_client_set_icon(SAY2_CLIENT(user), icon, icon_sz);

	channel = SAY2_CHANNEL(gtk_object_new(
		SAY2_TYPE_CHANNEL,
		"id", "gayukladz",
		"email", "gayukladz@egroups.com",
		"tagline", "Vote for the location of the channel meet!",
		"client", "Sephiroth 0.0.0",
		"host", "localhost",
		NULL
	));

	win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	box = gtk_vbox_new(FALSE, 4);
	gtk_container_set_border_width(GTK_CONTAINER(box), 4);
	gtk_container_add(GTK_CONTAINER(win), box);
	gtk_widget_show(box);

	wid = gtk_widget_new(MEKO_TYPE_CLIENT_INFO,
			     "client", SAY2_CLIENT(user),
			     "show_online", TRUE,
			     "with_status", FALSE,
			     NULL);
	gtk_box_pack_start(GTK_BOX(box), wid, FALSE, FALSE, 0);
	gtk_widget_show(wid);


	wid = gtk_widget_new(MEKO_TYPE_CLIENT_INFO,
			     "client", SAY2_CLIENT(user),
			     "show_online", TRUE,
			     "with_status", TRUE,
			     NULL);
	gtk_box_pack_start(GTK_BOX(box), wid, FALSE, FALSE, 0);
	gtk_widget_show(wid);

	wid = gtk_widget_new(MEKO_TYPE_CLIENT_INFO,
			     "client", SAY2_CLIENT(channel),
			     "show_online", TRUE,
			     "with_status", TRUE,
			     NULL);
	gtk_box_pack_start(GTK_BOX(box), wid, FALSE, FALSE, 0);
	gtk_widget_show(wid);

	gtk_widget_show(win);

	gtk_main();

	return 0;
}
