#include <meko.h>

#include <stdio.h>

#include <gtk/gtkmain.h>
#include <gtk/gtksignal.h>
#include <gtk/gtkwidget.h>
#include <gtk/gtkcontainer.h>
#include <gtk/gtkwindow.h>
#include <gtk/gtkbox.h>
#include <gtk/gtkvbox.h>
#include <gtk/gtkscrolledwindow.h>
#include <gtk/gtkbutton.h>
#include <libgnome/gnome-defs.h>
#include <libgnome/gnome-i18n.h>
#include <libgnomeui/gnome-init.h>

#include "say2/say2-client.h"
#include "say2/say2-channel.h"
#include "say2/say2-user.h"
#include "widgets/client-list/meko-client-list.h"

Say2Client *keybuk, *jay, *jt, *robin, *smess;
GtkWidget  *list;

static void
make_users(void)
{
	FILE *fd;
	char  icon[4096];
	int   icon_sz;

	fd = fopen("/home/scott/say2-jay.png", "r");
	icon_sz = fread(icon, 1, sizeof(icon), fd);
	fclose(fd);

	jay = SAY2_CLIENT(gtk_object_new(
		SAY2_TYPE_USER,
		"id", "jay",
		"nick", "Jay21Sx",
		"email", "jay@gayukladz.com",
		"tagline", "Bah, what a terrible day",
		"status", SAY2_USER_AWAY,
		NULL
	));
	say2_client_set_icon(jay, icon, icon_sz);
	gtk_object_ref(GTK_OBJECT(jay));

	fd = fopen("/home/scott/say2-jt.png", "r");
	icon_sz = fread(icon, 1, sizeof(icon), fd);
	fclose(fd);

	jt = SAY2_CLIENT(gtk_object_new(
		SAY2_TYPE_USER,
		"id", "jt",
		"nick", "JT",
		"email", "johnt_22_uk@hotmail.com",
		"tagline", "It's Haribo Time!!",
		"status", SAY2_USER_ACTIVE,
		NULL
	));
	say2_client_set_icon(jt, icon, icon_sz);
	gtk_object_ref(GTK_OBJECT(jt));

	fd = fopen("/home/scott/me-say2.png", "r");
	icon_sz = fread(icon, 1, sizeof(icon), fd);
	fclose(fd);

	keybuk = SAY2_CLIENT(gtk_object_new(
		SAY2_TYPE_USER,
		"id", "keybuk",
		"guest", FALSE,
		"nick", "Keybuk",
		"email", "scott@netsplit.com",
		"tagline", "Saving the world from disaster since 1980!",
		"client", "Meko 0.10.0",
		"host", "localhost",
		"status", SAY2_USER_BUSY,
		"status_msg", "Programming more of Meko",
		"status_time", time(NULL),
		NULL
	));
	say2_client_set_icon(keybuk, icon, icon_sz);
	gtk_object_ref(GTK_OBJECT(keybuk));

	fd = fopen("/home/scott/say2-robin.png", "r");
	icon_sz = fread(icon, 1, sizeof(icon), fd);
	fclose(fd);

	robin = SAY2_CLIENT(gtk_object_new(
		SAY2_TYPE_USER,
		"id", "robin",
		"nick", "Robin|22",
		"email", "robin@somewhere.com",
		"status", SAY2_USER_IDLE,
		NULL
	));
	say2_client_set_icon(robin, icon, icon_sz);
	gtk_object_ref(GTK_OBJECT(robin));

	fd = fopen("/home/scott/say2-smess.png", "r");
	icon_sz = fread(icon, 1, sizeof(icon), fd);
	fclose(fd);

	smess = SAY2_CLIENT(gtk_object_new(
		SAY2_TYPE_USER,
		"id", "smess",
		"nick", "Smess",
		"email", "smess@cress.org.uk",
		"tagline", "Ribena ribena ribena",
		"status", SAY2_USER_ACTIVE,
		"status_msg", "b0pping to: Radiohead - Crap Song",
		"status_time", time(NULL),
		NULL
	));
	say2_client_set_icon(smess, icon, icon_sz);
	gtk_object_ref(GTK_OBJECT(smess));
}

static void
add_cb(GtkWidget *widget, gpointer data)
{
	meko_client_list_add(MEKO_CLIENT_LIST(list), robin);
}

static void
remove_cb(GtkWidget *widget, gpointer data)
{
	meko_client_list_remove(MEKO_CLIENT_LIST(list), keybuk);
}

static void
change_cb(GtkWidget *widget, gpointer data)
{
	gtk_object_set(GTK_OBJECT(jt),
		       "nick", "Away [JT]",
		       "status", SAY2_USER_OFFLINE,
		       "status_msg", "Going offline for a bit",
		       "status_time", time(NULL),
		       NULL);
}

static void
destroy_cb(GtkWidget *widget, gpointer data)
{
	gtk_main_quit();
}

static void
activate_cb(GtkList *list, Say2Client *client, gpointer user_data)
{

	g_print("Activate called on %s\n", client->id);
}

int
main(int argc, char *argv[])
{
	GtkWidget *win, *vbox, *scrwin, *wid;

	bindtextdomain(PACKAGE, MEKO_LOCALEDIR);
	textdomain(PACKAGE);

	gnome_init(APPNAME, VERSION, argc, argv);

	make_users();

	win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(win), 195, 300);
	gtk_signal_connect(GTK_OBJECT(win), "destroy",
			   GTK_SIGNAL_FUNC(destroy_cb), NULL);

	vbox = gtk_vbox_new(FALSE, 2);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 4);
	gtk_container_add(GTK_CONTAINER(win), vbox);
	gtk_widget_show(vbox);

	scrwin = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrwin),
				       GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
	gtk_box_pack_start(GTK_BOX(vbox), scrwin, TRUE, TRUE, 0);
	gtk_widget_show(scrwin);

	list = meko_client_list_new();
	gtk_object_set(GTK_OBJECT(list), "show_online", TRUE, NULL);
	gtk_list_set_selection_mode(GTK_LIST(list), GTK_SELECTION_MULTIPLE);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrwin),list);
	gtk_signal_connect(GTK_OBJECT(list), "activate", 
			   GTK_SIGNAL_FUNC(activate_cb), NULL);
	gtk_widget_show(list);

	wid = gtk_button_new_with_label("Add Robin");
	gtk_signal_connect(GTK_OBJECT(wid), "clicked",
			   GTK_SIGNAL_FUNC(add_cb), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), wid, FALSE, FALSE, 0);
	gtk_widget_show(wid);

	wid = gtk_button_new_with_label("Remove Keybuk");
	gtk_signal_connect(GTK_OBJECT(wid), "clicked",
			   GTK_SIGNAL_FUNC(remove_cb), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), wid, FALSE, FALSE, 0);
	gtk_widget_show(wid);

	wid = gtk_button_new_with_label("Change JT");
	gtk_signal_connect(GTK_OBJECT(wid), "clicked",
			   GTK_SIGNAL_FUNC(change_cb), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), wid, FALSE, FALSE, 0);
	gtk_widget_show(wid);

	meko_client_list_add(MEKO_CLIENT_LIST(list), keybuk);
	meko_client_list_add(MEKO_CLIENT_LIST(list), jay);
	meko_client_list_add(MEKO_CLIENT_LIST(list), smess);
	meko_client_list_add(MEKO_CLIENT_LIST(list), jt);

	gtk_widget_show(win);

	gtk_main();

	return 0;
}
