/* meko
 * Copyright (C) 2001 Scott James Remnant <scott@netsplit.com>.
 * All Rights Reserved.
 *
 * image-widget.c
 *  - Image widget creation
 * -- 
 * $Id: image-widget.c,v 1.1.4.1 2001/11/23 22:19:55 scott Exp $
 * 
 * This file is distributed according to the GNU General Public
 * License.  For full details, read the top of 'main.c' or the
 * file called COPYING that was distributed with this code.
 */

#include <meko.h>

#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtkobject.h>
#include <gtk/gtkwidget.h>
#include <libgnome/gnome-defs.h>
#include <libgnome/gnome-util.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#include "util/gui/pixbuf-canvas.h"

#include "image-widget.h"

/* meko_create_image_widget
 * Create a widget containing an arbitrary image from the Meko art directory.
 * Actually returns it inside a Canvas, so it's antialiased and pretty.
 * The strange paramets are because this is mostly used from Glade.
 */
GtkWidget *
meko_create_image_widget(gchar *name, gchar *string1, gchar *string2,
			 gint int1, gint int2)
{
	GdkPixbuf *pixbuf;
	gchar	  *filename;

	if (!string1)
		return NULL;

	/* Load the pixbuf from the MEKO_IMAGESDIR directory */
	filename = g_concat_dir_and_file(MEKO_IMAGESDIR, string1);
	pixbuf = gdk_pixbuf_new_from_file(filename);
	g_free(filename);

	/* Return it in a canvas */
	return meko_create_pixbuf_canvas(pixbuf);
}
