/* meko
 * Copyright (C) 2001 Scott James Remnant <scott@netsplit.com>.
 * All Rights Reserved.
 *
 * client-label.c
 *  - Returns a string name for a Say2Client
 * -- 
 * $Id: client-label.c,v 1.1 2001/09/17 10:31:02 scott Exp $
 * 
 * This file is distributed according to the GNU General Public
 * License.  For full details, read the top of 'main.c' or the
 * file called COPYING that was distributed with this code.
 */

#include <meko.h>

#include <glib.h>
#include <gtk/gtkobject.h>

#include "say2/say2-client.h"
#include "say2/say2-user.h"

#include "client-label.h"

/* meko_say2_client_label
 * Choose an appropriate label for a Say2Client
 */
const gchar *
meko_say2_client_label(Say2Client *client)
{
	const gchar *nick, *id;

	g_return_val_if_fail(client != NULL, NULL);

	nick = id = NULL;
	if (SAY2_IS_USER(client))
		gtk_object_get(GTK_OBJECT(client), "nick", &nick, NULL);
	gtk_object_get(GTK_OBJECT(client), "id", &id, NULL);

	return nick ? nick : id;
}
