/* meko
 * Copyright (C) 2001 Scott James Remnant <scott@netsplit.com>.
 * All Rights Reserved.
 *
 * meko-client-info.h
 * -- 
 * $Id: meko-client-info.h,v 1.11.4.1 2001/11/23 22:19:55 scott Exp $
 *
 * This file is distributed according to the GNU General Public
 * License.  For full details, read the top of 'main.c' or the
 * file called COPYING that was distributed with this code.
 */

#ifndef _MEKO_CLIENT_INFO_H
#define _MEKO_CLIENT_INFO_H

/* Required includes */
#include <glib.h>
#include <gtk/gtktooltips.h>
#include <libgnomeui/gnome-canvas.h>
#include <libgnomeui/gnome-canvas-widget.h>

#include "say2/say2-client.h"

/* Convenience defines */
#define MEKO_TYPE_CLIENT_INFO \
	(meko_client_info_get_type())
#define MEKO_CLIENT_INFO(obj) \
	(GTK_CHECK_CAST((obj), MEKO_TYPE_CLIENT_INFO, MekoClientInfo))
#define MEKO_CLIENT_INFO_CLASS(klass) \
	(GTK_CHECK_CLASS_CAST((klass), MEKO_TYPE_CLIENT_INFO, \
			      MekoClientInfoClass))
#define MEKO_IS_CLIENT_INFO(obj) \
	(GTK_CHECK_TYPE((obj), MEKO_TYPE_CLIENT_INFO))
#define MEKO_IS_CLIENT_INFO_CLASS(klass) \
	(GTK_CHECK_CLASS_TYPE((klass), MEKO_TYPE_CLIENT_INFO))

/* Typedefs */
typedef struct _meko_client_info	MekoClientInfo;
typedef struct _meko_client_info_class	MekoClientInfoClass;

/* Instance data */
struct _meko_client_info {
	GnomeCanvas canvas;

	/* Arguments */
	Say2Client *client;
	guint	    with_status : 1;
	guint	    show_online : 1;

	/* Private */
	GnomeCanvasItem *bg, *rect, *icon, *status, *hand, *nick, *email, *text;
	GtkTooltips     *tips;
	guint		 client_changed_sigh;
};

/* Object class data */
struct _meko_client_info_class {
	GnomeCanvasClass parent_class;

	/* Signals */
	void (*remodel)(MekoClientInfo *);
	void (*recolor)(MekoClientInfo *);
};


/* Required functions */
GtkWidget *meko_client_info_new(Say2Client *);
GtkType	   meko_client_info_get_type(void);

/* Set arguments */
void meko_client_info_set_client(MekoClientInfo *, Say2Client *);
void meko_client_info_set_with_status(MekoClientInfo *, gboolean);
void meko_client_info_set_show_online(MekoClientInfo *, gboolean);

/* Get arguments */
Say2Client *meko_client_info_get_client(MekoClientInfo *);
gboolean    meko_client_info_get_with_status(MekoClientInfo *);
gboolean    meko_client_info_get_show_online(MekoClientInfo *);

#endif /* !_MEKO_CLIENT_INFO_H */
