/* meko
 * Copyright (C) 2001 Scott James Remnant <scott@netsplit.com>.
 * All Rights Reserved.
 *
 * meko-client-list.h
 * -- 
 * $Id: meko-client-list.h,v 1.6 2001/09/11 11:03:37 scott Exp $
 *
 * This file is distributed according to the GNU General Public
 * License.  For full details, read the top of 'main.c' or the
 * file called COPYING that was distributed with this code.
 */

#ifndef _MEKO_CLIENT_LIST_H
#define _MEKO_CLIENT_LIST_H

/* Required includes */
#include <glib.h>
#include <gtk/gtklist.h>

#include "say2/say2-client.h"

/* Convenience defines */
#define MEKO_TYPE_CLIENT_LIST \
	(meko_client_list_get_type())
#define MEKO_CLIENT_LIST(obj) \
	(GTK_CHECK_CAST((obj), MEKO_TYPE_CLIENT_LIST, MekoClientList))
#define MEKO_CLIENT_LIST_CLASS(klass) \
	(GTK_CHECK_CLASS_CAST((klass), MEKO_TYPE_CLIENT_LIST, \
			      MekoClientListClass))
#define MEKO_IS_CLIENT_LIST(obj) \
	(GTK_CHECK_TYPE((obj), MEKO_TYPE_CLIENT_LIST))
#define MEKO_IS_CLIENT_LIST_CLASS(klass) \
	(GTK_CHECK_CLASS_TYPE((klass), MEKO_TYPE_CLIENT_LIST))

/* Typedefs */
typedef struct _meko_client_list	MekoClientList;
typedef struct _meko_client_list_class	MekoClientListClass;

/* Instance data */
struct _meko_client_list {
	GtkList list;

	/* Arguments */
	guint show_online : 1;
};

/* Object class data */
struct _meko_client_list_class {
	GtkListClass parent_class;

	/* Signals */
	void (*activate)(MekoClientList *, Say2Client *);
	void (*dropped)(MekoClientList *, const gchar *);
};


/* Required functions */
GtkWidget *meko_client_list_new(void);
GtkType	   meko_client_list_get_type(void);

/* Set arguments */
void meko_client_list_set_show_online(MekoClientList *, gboolean);

/* Get arguments */
gboolean meko_client_list_get_show_online(MekoClientList *);

/* Add and Remove items from the list */
void meko_client_list_add(MekoClientList *, Say2Client *);
void meko_client_list_remove(MekoClientList *, Say2Client *);

#endif /* !_MEKO_CLIENT_LIST_H */
