/* meko
 * Copyright (C) 2001 Scott James Remnant <scott@netsplit.com>.
 * All Rights Reserved.
 *
 * meko-status-menu-dialog.h
 * -- 
 * $Id: meko-status-menu-dialog.h,v 1.3.2.1 2001/11/23 22:19:55 scott Exp $
 * 
 * This file is distributed according to the GNU General Public
 * License.  For full details, read the top of 'main.c' or the
 * file called COPYING that was distributed with this code.
 */

#ifndef _MEKO_STATUS_MENU_DIALOG_H
#define _MEKO_STATUS_MENU_DIALOG_H

#include <glib.h>
#include <gtk/gtkobject.h>
#include <gtk/gtkwidget.h>
#include <libgnome/gnome-defs.h>
#include <libgnomeui/gnome-dialog.h>
#include <glade/glade-xml.h>

#include "say2/say2-user.h"

/* Convenience defines */
#define MEKO_TYPE_STATUS_MENU_DIALOG \
	(meko_status_menu_dialog_get_type())
#define MEKO_STATUS_MENU_DIALOG(obj) \
	(GTK_CHECK_CAST((obj), MEKO_TYPE_STATUS_MENU_DIALOG, \
			MekoStatusMenuDialog))
#define MEKO_STATUS_MENU_DIALOG_CLASS(klass) \
	(GTK_CHECK_CLASS_CAST((klass), MEKO_TYPE_STATUS_MENU_DIALOG, \
			      MekoStatusMenuDialogKlass))
#define MEKO_IS_STATUS_MENU_DIALOG(obj) \
	(GTK_CHECK_TYPE((obj), MEKO_TYPE_STATUS_MENU_DIALOG))
#define MEKO_IS_STATUS_MENU_DIALOG_CLASS(klass) \
	(GTK_CHECK_CLASS_TYPE((klass), MEKO_TYPE_STATUS_MENU_DIALOG))


/* Typedefs */
typedef struct _meko_status_menu_dialog       MekoStatusMenuDialog;
typedef struct _meko_status_menu_dialog_class MekoStatusMenuDialogClass;

/* Instance data */
struct _meko_status_menu_dialog {
	GnomeDialog dialog;

	/* Private stuff */
	GtkWidget *entry_message;
	GtkWidget *checkbutton_receive;
};

/* Object class data */
struct _meko_status_menu_dialog_class {
	GnomeDialogClass parent_class;

	/* Signals */
	void (*construct)(MekoStatusMenuDialog *, Say2UserStatus);
};


/* Required functions */
GtkWidget *meko_status_menu_dialog_new(Say2UserStatus);
GtkType	   meko_status_menu_dialog_get_type(void);

/* Return the contents of the dialog */
const gchar *meko_status_menu_dialog_get_message(MekoStatusMenuDialog *);
gboolean     meko_status_menu_dialog_get_receive(MekoStatusMenuDialog *);

#endif /* !_MEKO_STATUS_MENU_DIALOG_H */
