/* meko
 * Copyright (C) 2001 Scott James Remnant <scott@netsplit.com>.
 * All Rights Reserved.
 *
 * meko-status-menu.h
 * -- 
 * $Id: meko-status-menu.h,v 1.2.4.1 2001/11/23 22:19:55 scott Exp $
 *
 * This file is distributed according to the GNU General Public
 * License.  For full details, read the top of 'main.c' or the
 * file called COPYING that was distributed with this code.
 */

#ifndef _MEKO_STATUS_MENU_H
#define _MEKO_STATUS_MENU_H

/* Required includes */
#include <glib.h>
#include <gtk/gtkbutton.h>
#include <gtk/gtkmenu.h>

#include "say2/say2-user.h"

/* Convenience defines */
#define MEKO_TYPE_STATUS_MENU \
	(meko_status_menu_get_type())
#define MEKO_STATUS_MENU(obj) \
	(GTK_CHECK_CAST((obj), MEKO_TYPE_STATUS_MENU, MekoStatusMenu))
#define MEKO_STATUS_MENU_CLASS(klass) \
	(GTK_CHECK_CLASS_CAST((klass), MEKO_TYPE_STATUS_MENU, \
			      MekoStatusMenuClass))
#define MEKO_IS_STATUS_MENU(obj) \
	(GTK_CHECK_TYPE((obj), MEKO_TYPE_STATUS_MENU))
#define MEKO_IS_STATUS_MENU_CLASS(klass) \
	(GTK_CHECK_CLASS_TYPE((klass), MEKO_TYPE_STATUS_MENU))

/* Typedefs */
typedef struct _meko_status_menu       MekoStatusMenu;
typedef struct _meko_status_menu_class MekoStatusMenuClass;

/* Instance data */
struct _meko_status_menu {
	GtkButton button;

	/* Arguments */
	Say2User *user;
	gchar	 *text;

	/* Members */
	Say2UserStatus  status, set_status;
	GtkWidget      *menu, *box, *label, *pixmap;
	guint		user_changed_sigh;
};

/* Object class data */
struct _meko_status_menu_class {
	GtkButtonClass parent_class;

	/* Signals */
	void (*changed)(MekoStatusMenu *, Say2UserStatus);
};


/* Required functions */
GtkWidget *meko_status_menu_new(Say2User *);
GtkType	   meko_status_menu_get_type(void);

/* Set arguments */
void meko_status_menu_set_user(MekoStatusMenu *, Say2User *);
void meko_status_menu_set_text(MekoStatusMenu *, const gchar *);

/* Get arguments */
Say2User *meko_status_menu_get_user(MekoStatusMenu *);
gchar *   meko_status_menu_get_text(MekoStatusMenu *);

/* Set and get the current value */
void	       meko_status_menu_set_value(MekoStatusMenu *, Say2UserStatus);
Say2UserStatus meko_status_menu_get_value(MekoStatusMenu *);

#endif /* !_MEKO_STATUS_MENU_H */
